Attribute VB_Name = "modComplex"
'Modul fr Rechenoperationen mit komplexen Zahlen

Option Explicit

Public ComplexNull As Complex

'# Stcker Mathe 531

'Addieren
Function AddC(Z1 As Complex, Z2 As Complex) As Complex
AddC.Re = Z1.Re + Z2.Re
AddC.Im = Z1.Im + Z2.Im
End Function

'Multiplizieren
Function MultiplyC(Z1 As Complex, Z2 As Complex) As Complex
MultiplyC.Re = Z1.Re * Z2.Re - Z1.Im * Z2.Im
MultiplyC.Im = Z1.Re * Z2.Im + Z2.Re * Z1.Im
End Function

'Dividieren
Function DivideC(Z1 As Complex, Z2 As Complex) As Complex
DivideC.Re = (Z1.Re * Z2.Re + Z1.Im * Z2.Im) / (Z2.Re ^ 2 + Z2.Im ^ 2)
DivideC.Im = (Z2.Re * Z1.Im - Z1.Re * Z2.Im) / (Z2.Re ^ 2 + Z2.Im ^ 2)
End Function

'Konjugiert
Function ConjugateC(Z As Complex) As Complex
ConjugateC.Re = Z.Re
ConjugateC.Im = -Z.Im
End Function

'Betrag (Stcker Mathe 527)
Function AbsC(Z As Complex) As Double
AbsC = (Z.Re ^ 2 + Z.Im ^ 2) ^ 0.5
End Function


'Funktion um den Phasenwinkel zu erhalten

'^ Im
'|     . Abs
'|   .            tan Phi = Im / Re
'| .\----- Phi
'|__)___________> Re

Function GetPhi(Expression As Complex) As Double ' Ergebniss: Ein Wert zwischen -180 und +180
If Expression.Re = 0 And Expression.Im = 0 Then Exit Function
If Expression.Re = 0 Then GetPhi = 90 * Sgn(Expression.Im): Exit Function
GetPhi = Atn(Expression.Im / Expression.Re) * (180 / Pi) - 180 * (Sgn(Expression.Re) = -1) * ((Sgn(Expression.Im) = -1) * 2 + 1)
End Function

Public Sub test()
Dim a1 As Complex, a2 As Complex, a3 As Complex
a1.Im = 1
a2.Im = 1
a3 = MultiplyC(a1, a2)
MsgBox a3.Re & " + " & a3.Im & " j"
End Sub
