Attribute VB_Name = "modFkt1"
'##### Diverse (mathematische) Funktionen #####

Option Explicit

Dim ZahlX As Integer, ZahlY As Integer, n As Integer

'y-Koordinate einer Zelle bestimmen
Function GetRowByNr(ZellenNr As Integer) As Integer
If ZellenNr Mod hZellen = 0 Then
    GetRowByNr = ZellenNr / hZellen
Else
    GetRowByNr = (ZellenNr \ hZellen) + 1
End If
End Function

'x-Koordinate einer Zelle bestimmen
Function GetColByNr(ZellenNr As Integer) As Integer
If ZellenNr Mod hZellen = 0 Then
    GetColByNr = hZellen
Else
    GetColByNr = ZellenNr Mod hZellen
End If
End Function

'y-Koordinate einer Zelle bestimmen
Function GetRowByNr_W(ZellenNr As Integer, Width As Integer) As Integer
If ZellenNr Mod Width = 0 Then
    GetRowByNr_W = ZellenNr / Width
Else
    GetRowByNr_W = (ZellenNr \ Width) + 1
End If
End Function

'x-Koordinate einer Zelle bestimmen
Function GetColByNr_W(ZellenNr As Integer, Width As Integer) As Integer
If ZellenNr Mod Width = 0 Then
    GetColByNr_W = Width
Else
    GetColByNr_W = ZellenNr Mod Width
End If
End Function

'Zelle mittels der X/Y Koordinaten bestimmen
Function GetNrByXY(X As Integer, Y As Integer) As Integer
If X > 0 And X <= hZellen And Y > 0 And Y <= vZellen Then
      GetNrByXY = (Y - 1) * hZellen + X
End If
End Function
 
'Zelle mittels der XY - Pixelkoordinaten bestimmen
Function GetNrByCon(ByVal X As Integer, ByVal Y As Integer) As Integer
ZahlX = CInt((X - WSRand + 17) / 33)
ZahlY = CInt((Y - WSRand + 17) / 33)
GetNrByCon = GetNrByXY(ZahlX, ZahlY)
End Function

'X-Koordinate mittels der X-Pixelkoordinate bestimmen
Function GetXByCon(ByVal X As Integer) As Integer
Dim newX As Integer
ZahlX = CInt((X - WSRand + 17) / 33)
GetXByCon = (X - WSRand) - ((ZahlX - 1) * 33)
If GetXByCon = 32 Then GetXByCon = 31
End Function

'Y-Koordinate mittels der Y-Pixelkoordinate bestimmen
Function GetYByCon(ByVal Y As Integer) As Integer
Dim newY As Integer
ZahlY = CInt((Y - WSRand + 17) / 33)
GetYByCon = (Y - WSRand) - ((ZahlY - 1) * 33)
If GetYByCon = 32 Then GetYByCon = 31
End Function

'Bestimmung der Entfernung zwischen zwei Punkten im Koordinatensystem (Satz d. Pythagoras)
Function Distance(ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Single
Distance = Sqr((X2 - X1) ^ 2 + (Y2 - Y1) ^ 2)
End Function

'Sub zum Bekommen des Pfades einer Anwendung (mit Backslash)
Function GetAppPath() As String
If Len(App.Path) = 3 Then
    GetAppPath = App.Path
Else
    GetAppPath = App.Path & "\"
End If
End Function

'Sub zum Leeren einer Collection
Sub ClearCol(objekt As Collection)
Do Until objekt.Count = 0
    objekt.Remove (1)
Loop
End Sub

'Funktion um den Zustand des n.ten Bites einer maximal 3-bittigen Kette zu erhalten
Function GetBit(ByVal Expression As Byte, ByVal BitNr As Byte) As Byte
Dim Bits(1 To 3) As Byte
For n = 3 To 1 Step -1
    If Expression >= 2 ^ (n - 1) Then
        Bits(n) = 1
        Expression = Expression - 2 ^ (n - 1)
    End If
Next
GetBit = Bits(BitNr)
End Function

'Findet heraus ob sich der Mauszeiger im Feld eines Steuerelementes mit gegebener hWnd befindet
Function MouseInRect(RecthWnd As Long, Optional DiffLeft As Integer, Optional DiffTop As Integer, Optional DiffRight As Integer, Optional DiffBottom As Integer) As Boolean
Call GetCursorPos(CursorPos)
Call GetWindowRect(RecthWnd, RectPos)
If CursorPos.X >= (RectPos.Left + DiffLeft) And CursorPos.X <= (RectPos.Right - DiffRight) And CursorPos.Y >= (RectPos.Top + DiffTop) And CursorPos.Y <= (RectPos.Bottom - DiffBottom) Then MouseInRect = True
End Function

'Wandelt eine Single Zahl exakt in eine Double um
Function SngToDbl(Expression As Single) As Double
SngToDbl = CDbl(Format(Expression))
End Function

'Schreibt einen Text an angebener Position in ein Control
Sub PrintText(Destination As Control, ByVal X As Single, ByVal Y As Single, ByVal Expression As String)
Destination.CurrentX = X
Destination.CurrentY = Y
Destination.Print Expression
End Sub

'Schreibt ein Label an angebener Position in ein Control
Sub PrintLabel(Destination As Control, ByVal Source As Control, Optional ByVal FineX As Single, Optional ByVal FineY As Single)
Destination.CurrentX = Source.Left + 1 + FineX
Destination.CurrentY = Source.Top + 1 + FineY
Destination.Print Source.Caption
End Sub

'Bogenmawinkel bestimmten
Function AngleR(X As Integer, Y As Integer) As Single
If X > 0 And Y > 0 Then
    AngleR = Atn(Y / X)
ElseIf X > 0 And Y < 0 Then
    AngleR = 2 * Pi + Atn(Y / X)
ElseIf X < 0 Then
    AngleR = Pi + Atn(Y / X)
ElseIf X = 0 Then
    AngleR = Sgn(Y) * (Pi / 2)
End If
End Function

'Sub zur berprfung ob ein anderes Bauelement berschrieben werden darf
Function AllowedToBuilt(Zelle As Integer) As Boolean
If (aZelle(Zelle).ID >= 26 And aZelle(Zelle).ID <= 30) Or (aZelle(Zelle).ID <= 19 And aZelle(Zelle).ID >= 1) Then
    AllowedToBuilt = False
Else
    AllowedToBuilt = True
End If
End Function

'Sub zur Koordinatendarstellung einer Zelle
Function CellXYstr(Zelle As Integer) As String
CellXYstr = "(" & GetColByNr(Zelle) & ";" & GetRowByNr(Zelle) & ")"
End Function
