Attribute VB_Name = "modRichtungen"
'##### Allgemeines Modul fr Richtungsoperationen #####

Option Explicit

Dim Dirs(1 To 3) As Byte
Dim n As Integer, m As Integer

'Umgekehrte Richtung finden
Function TurnD(ByVal Richtung As Byte) As Byte
If Richtung = 1 Or Richtung = 3 Then
     TurnD = Richtung - 1
Else
     TurnD = Richtung + 1
End If
End Function

'90 links
Function TurnDLeft(ByVal Richtung As Byte) As Byte
Select Case Richtung
    Case 0
        TurnDLeft = 3
    Case 1
        TurnDLeft = 2
    Case 2, 3
        TurnDLeft = Richtung - 2
End Select
End Function

'90 rechts
Function TurnDRight(ByVal Richtung As Byte) As Byte
Select Case Richtung
    Case 0, 1
        TurnDRight = Richtung + 2
    Case 2
        TurnDRight = 1
    Case 3
        TurnDRight = 0
End Select
End Function

'Richtung vom AusR Format in das Standardformat konvertieren (vom Zentrum abgehend)
Function RichtungByAusR(ByVal AusR As Byte) As Byte
Select Case AusR
    Case 0
        RichtungByAusR = 0
    Case 1
        RichtungByAusR = 3
    Case 2
        RichtungByAusR = 1
    Case 3
        RichtungByAusR = 2
End Select
End Function

'Funktion zum Auffinden der benachbarten Zelle in angegebener Richtung
Function NchsteZelle(ByVal Zelle As Integer, ByVal Richtung As Byte) As Integer
Select Case Richtung
    Case 1
        If GetColByNr(Zelle) < hZellen Then NchsteZelle = Zelle + 1
    Case 0
        If GetColByNr(Zelle) > 1 Then NchsteZelle = Zelle - 1
    Case 3
        If GetRowByNr(Zelle) < vZellen Then NchsteZelle = Zelle + hZellen
    Case 2
        If GetRowByNr(Zelle) > 1 Then NchsteZelle = Zelle - hZellen
End Select
End Function

'Funktion zum Herausfinden ob ein Bauelement ein Anschluss in gegebener Richtung besitzt
Function GetZellZone(Zelle As Integer, ByVal Richtung As Byte) As Boolean
Select Case aZelle(Zelle).ID
    Case 1 To 14, 16 To 18, 20, 21
        If aZelle(Zelle).AusR = 0 Or aZelle(Zelle).AusR = 2 Then
            If Richtung = 0 Or Richtung = 1 Then GetZellZone = True
        Else
            If Richtung = 2 Or Richtung = 3 Then GetZellZone = True
        End If
    Case 19
        If Not Richtung = TurnD(RichtungByAusR(aZelle(Zelle).AusR)) Then GetZellZone = True
    Case 22
        If Richtung = 0 Or Richtung = 2 Then GetZellZone = True
    Case 23
        If Richtung = 0 Or Richtung = 3 Then GetZellZone = True
    Case 24
        If Richtung = 1 Or Richtung = 2 Then GetZellZone = True
    Case 25
        If Richtung = 1 Or Richtung = 3 Then GetZellZone = True
    Case 26
        If Not Richtung = 3 Then GetZellZone = True
    Case 27
        If Not Richtung = 2 Then GetZellZone = True
    Case 28
        If Not Richtung = 1 Then GetZellZone = True
    Case 29
        If Not Richtung = 0 Then GetZellZone = True
    Case 30
        GetZellZone = True
End Select
End Function

'Funktion um eine Verbindung aufgrund ihrer Anschlussrichtungen herauszufinden (z. B. 0, 1, 3 = Knotenpunkt LRU)
Function GetIDbyDir(ByVal Dir1 As Byte, Optional ByVal Dir2 As Byte = 10, Optional ByVal Dir3 As Byte = 10) As Byte
If Dir2 < 10 Then 'Sortieren
    m = 0
    For n = 0 To 3
        If Dir1 = n Or Dir2 = n Or Dir3 = n Then
            m = m + 1
            Dirs(m) = n
        End If
    Next
End If
If Dir2 = 10 Then                           'Verbindung
    If Dir1 = 0 Or Dir1 = 1 Then
        GetIDbyDir = 20
    Else
        GetIDbyDir = 21
    End If
Else
    If Dir3 = 10 Then                       'Eckpunkt
        If Dirs(1) = 0 And Dirs(2) = 2 Then
            GetIDbyDir = 22
        ElseIf Dirs(1) = 0 And Dirs(2) = 3 Then
            GetIDbyDir = 23
        ElseIf Dirs(1) = 1 And Dirs(2) = 2 Then
            GetIDbyDir = 24
        ElseIf Dirs(1) = 1 And Dirs(2) = 3 Then
            GetIDbyDir = 25
        End If
    Else                                    'Knotenpunkt
        If Dirs(1) = 0 And Dirs(2) = 1 And Dirs(3) = 2 Then
            GetIDbyDir = 26
        ElseIf Dirs(1) = 0 And Dirs(2) = 1 And Dirs(3) = 3 Then
            GetIDbyDir = 27
        ElseIf Dirs(1) = 0 And Dirs(2) = 2 And Dirs(3) = 3 Then
            GetIDbyDir = 28
        ElseIf Dirs(1) = 1 And Dirs(2) = 2 And Dirs(3) = 3 Then
            GetIDbyDir = 29
        End If
    End If
End If
End Function

'Funktion um die nummerierten Anschlussrichtungen eines Bauelementes herauszufinden (Umkehrfunktion zu GetDirByID)
Function GetDirByID(ByVal ID As Integer, Nr As Byte) As Byte
Select Case ID
    Case 22
        If Nr = 1 Then
            GetDirByID = 0
        ElseIf Nr = 2 Then
            GetDirByID = 2
        End If
    Case 23
        If Nr = 1 Then
            GetDirByID = 0
        ElseIf Nr = 2 Then
            GetDirByID = 3
        End If
    Case 24
        If Nr = 1 Then
            GetDirByID = 1
        ElseIf Nr = 2 Then
            GetDirByID = 2
        End If
    Case 25
        If Nr = 1 Then
            GetDirByID = 1
        ElseIf Nr = 2 Then
            GetDirByID = 3
        End If
End Select
End Function

'Ermitteln der dritten Richtung eines Knotenpunktes bei zwei bekannten
'Es gelten jeweils die Zonenrichtungen!!!
Function Get3rdR(Nr As Integer, ByVal r_1 As Byte, ByVal r_2 As Byte) As Byte
Dim n As Integer
For n = 0 To 3
    If Not r_1 = n And Not r_2 = n And GetZellZone(Nr, n) = True Then
        Get3rdR = n
        Exit For
    End If
Next
End Function

'Herausfinden ob die angegebene Richtung eines Wechselschalters weiter fhrt
Function CheckSwitchR(ByVal Zelle As Integer, ByVal Richtung As Byte) As Boolean
If Richtung = RichtungByAusR(aZelle(Zelle).AusR) Then
    CheckSwitchR = True
Else
    If aZelle(Zelle).Param1 = 0 Then 'links
        If Richtung = TurnDRight(RichtungByAusR(aZelle(Zelle).AusR)) Then CheckSwitchR = True
    Else                             'rechts
        If Richtung = TurnDLeft(RichtungByAusR(aZelle(Zelle).AusR)) Then CheckSwitchR = True
    End If
End If
End Function

'Freie Richtung suchen (linker Rand -> Rand = 0; Mitte -> Rand = 10)
Function SearchFreeDir(ByVal Nr As Integer, ByRef Dir As Byte, ByRef cDirs As Byte, Rand()) As Boolean
Dim i_cDirs As Byte
For n = 0 To 3
    If GetZellZone(Nr, n) = True Then
        If NchsteZelle(Nr, n) = Nr Or aZelle(NchsteZelle(Nr, n)).ID = 0 Or CompareRand(n, Rand) = True Then
            SearchFreeDir = True
            Dir = n
            i_cDirs = i_cDirs + 1
        End If
    End If
Next
cDirs = i_cDirs
End Function

'berprfen des Rand-Arrays
Function CompareRand(ByVal valRand As Byte, Rand()) As Boolean
If Rand(0) = 10 Then Exit Function
For m = 0 To UBound(Rand)
    If valRand = Rand(m) Then
        CompareRand = True
        Exit Function
    End If
Next
End Function


