Attribute VB_Name = "modXML"
'##### Parsing / Composing Modul fr die Zwischenablage / Dateioperationen #####
'##### XML basiert #####

Option Explicit

Dim n As Integer

'Ersetzen von speziellen Zeichen durch XML Maskierungen
Private Function XML_Encode(Expression As String) As String
If Len(Expression) = 0 Then Exit Function
Expression = Replace(Expression, "&", "&amp;")
Expression = Replace(Expression, "<", "&lt;")
Expression = Replace(Expression, ">", "&gt;")
Expression = Replace(Expression, """", "&quot;")
Expression = Replace(Expression, "'", "&apos;")
XML_Encode = Expression
End Function

'Maskierungen wieder durch tatschliche Zeichen ersetzen
Private Function XML_Decode(ByVal Expression As String) As String
If Len(Expression) = 0 Then Exit Function
Expression = Replace(Expression, "&lt;", "<")
Expression = Replace(Expression, "&gt;", ">")
Expression = Replace(Expression, "&quot;", """")
Expression = Replace(Expression, "&apos;", "'")
Expression = Replace(Expression, "&amp;", "&")
XML_Decode = Expression
End Function

'Parsen einer XML Datei
Function ParseFile(Pfad As String) As Boolean
Dim Pos As Long, Code As String, readIn As String
Pos = 1
Open Pfad For Input As #1
    Do
        Line Input #1, readIn
        Code = Code & readIn
    Loop Until EOF(1)
Close #1
Pos = InStr(Pos, Code, "<project>")
If Pos = 0 Then Exit Function
ProjektName = FindTag(Code, "title", Pos)
Pos = InStr(Pos, Code, "<area ")
If Pos = 0 Then Exit Function
hZellen = FindAttribute(Code, "width", Pos)
vZellen = FindAttribute(Code, "height", Pos)
CreateArrays
Do
    Pos = InStr(Pos, Code, "<cell ")
    If Pos = 0 Then Exit Do
    ParseCellF Mid(Code, Pos, InStr(Pos, Code, "</cell>") - Pos), GetNrByXY(FindAttribute(Code, "x", Pos), FindAttribute(Code, "y", Pos))
    Pos = InStr(Pos, Code, "</cell>")
    If Pos = 0 Then Exit Do
Loop
ParseFile = True
End Function

'Parsen der Zwischenablage
Sub ParseClipboard(Code As String)
Dim Pos As Long, BaseX As Integer, BaseY As Integer, LenX As Integer, LenY As Integer
Pos = InStr(Code, "<area ")
If Pos > 0 Then 'Area parsen
    BaseX = GetColByNr(frmHaupt.mZ)
    BaseY = GetRowByNr(frmHaupt.mZ)
    LenX = FindAttribute(Code, "width", Pos)
    LenY = FindAttribute(Code, "height", Pos)
    ReDim aZelle_n(LenX * LenY)
    'Zellen in aZelle_n schreiben
    Do
        Pos = InStr(Pos, Code, "<cell ")
        If Pos = 0 Then Exit Do
        ParseCellC Code, Pos, (FindAttribute(Code, "y", Pos) - 1) * LenX + FindAttribute(Code, "x", Pos)
        Pos = InStr(Pos, Code, "</cell>")
    Loop
    'aZelle_n in aZelle bertragen
    For n = 1 To LenX * LenY
        aZelle(GetNrByXY(BaseX + GetColByNr_W(n, LenX) - 1, BaseY + GetRowByNr_W(n, LenX) - 1)) = aZelle_n(n)
    Next
    frmHaupt.Markiere GetColByNr(frmHaupt.mZ), GetRowByNr(frmHaupt.mZ), LenX, LenY
Else 'Einzelne Zelle?
    Pos = InStr(Code, "<cell ")
    If Pos > 0 Then
        ParseCellF Code, frmHaupt.mZ
    End If
End If
End Sub

'Zelle parsen Clipboard
Private Sub ParseCellC(Code As String, Pos As Long, Nr As Integer)
aZelle_n(Nr).AusR = FindAttribute(Code, "direction", Pos)
aZelle_n(Nr).ID = FindAttribute(Code, "id", Pos)
aZelle_n(Nr).Kommentar = XML_Decode(FindTag(Code, "comment", Pos))
aZelle_n(Nr).Param1 = FindTag(Code, "param1", Pos)
aZelle_n(Nr).Param2 = FindTag(Code, "param2", Pos)
End Sub

'Zelle parsen Datei
Private Sub ParseCellF(Code As String, Nr As Integer)
aZelle(Nr).AusR = FindAttribute(Code, "direction")
aZelle(Nr).ID = FindAttribute(Code, "id")
aZelle(Nr).Kommentar = XML_Decode(FindTag(Code, "comment"))
aZelle(Nr).Param1 = FindTag(Code, "param1")
aZelle(Nr).Param2 = FindTag(Code, "param2")
End Sub

'Wert eines gegebenen Attributes herausfinden
Private Function FindAttribute(Code As String, AttName As String, Optional ByVal Pos As Long = 1) As Variant
Pos = InStr(Pos, Code, " " & AttName)
If Pos = 0 Then Exit Function
Pos = InStr(Pos, Code, """") + 1 'Beginn Inhalt
If Pos = 1 Then Exit Function
If InStr(Pos, Code, """") = 0 Then Exit Function
FindAttribute = Mid(Code, Pos, InStr(Pos, Code, """") - Pos)
End Function

'Wert zwischen einem einschlieenden Tag herausfinden
Private Function FindTag(Code As String, TagName As String, Optional ByVal Pos As Long = 1) As Variant
Pos = InStr(Pos, Code, "<" & TagName & ">")
If Pos = 0 Then Exit Function
Pos = InStr(Pos, Code, ">") + 1 'Beginn Inhalt
If Pos = 1 Then Exit Function
If InStr(Pos, Code, "<") = 0 Then Exit Function
FindTag = Mid(Code, Pos, InStr(Pos, Code, "<") - Pos)
End Function

'XML Code einer einzelnen Zelle generieren
'Position: 0 = keine; 1 = absolut; 2 = relativ;
Function CreateXMLCell(Nr As Integer, Optional Position As Byte = 1, Optional BaseCell As Integer) As String
Dim AdditionalAtts As String, SubTags As String
If aZelle(Nr).ID > 0 Then AdditionalAtts = " direction=""" & aZelle(Nr).AusR & """"
If Position = 0 Then
    CreateXMLCell = "    <cell id=""" & aZelle(Nr).ID & """" & AdditionalAtts & ">"
ElseIf Position = 1 Then
    CreateXMLCell = "    <cell id=""" & aZelle(Nr).ID & """ x=""" & GetColByNr(Nr) & """ y=""" & GetRowByNr(Nr) & """" & AdditionalAtts & ">"
ElseIf Position = 2 Then
    CreateXMLCell = "    <cell id=""" & aZelle(Nr).ID & """ x=""" & GetColByNr(Nr) - GetColByNr(BaseCell) + 1 & """ y=""" & GetRowByNr(Nr) - GetRowByNr(BaseCell) + 1 & """" & AdditionalAtts & ">"
End If
If Not IDtoParam1(aZelle(Nr).ID) = "" Then SubTags = SubTags & "      <param1>" & aZelle(Nr).Param1 & "</param1>" & vbCrLf
If Not IDtoParam2(aZelle(Nr).ID) = "" Then SubTags = SubTags & "      <param2>" & aZelle(Nr).Param2 & "</param2>" & vbCrLf
If Not aZelle(Nr).Kommentar = "" Then SubTags = SubTags & "      <comment>" & XML_Encode(aZelle(Nr).Kommentar) & "</comment>" & vbCrLf
If Not SubTags = "" Then 'Unter-Tags vorhanden
    CreateXMLCell = CreateXMLCell & vbCrLf & SubTags & "    </cell>" & vbCrLf
Else 'Keine Unter-Tags
    CreateXMLCell = CreateXMLCell & "</cell>" & vbCrLf
End If
End Function

'Gesamte XML Datei generieren
Function CreateXMLFile() As String
CreateXMLFile = "<?xml version=""1.0"" encoding=""iso-8859-1""?>" & vbCrLf _
              & "<?xml-stylesheet type=""text/xsl"" href=""exactXML.xsl"" ?>" & vbCrLf _
              & "<project>" & vbCrLf _
              & "  <title>" & ProjektName & "</title>" & vbCrLf _
              & "  <area width=""" & hZellen & """ height=""" & vZellen & """>" & vbCrLf
                For n = 1 To hZellen * vZellen
                    CreateXMLFile = CreateXMLFile & CreateXMLCell(n)
                Next
CreateXMLFile = CreateXMLFile _
              & "  </area>" & vbCrLf _
              & "</project>"
End Function

'XML Datei speichern
Sub SaveXMLFile()
On Error Resume Next
Dim DataArray() As Byte
Open SpeicherOrt For Output As #1
    Print #1, CreateXMLFile
Close #1
If SpeichernDialog.XSL = 1 Then 'Web-XSL hinzufgen
    DataArray = LoadResData(101, "WEBXSLT")
    RemoveNullBytes DataArray
    If Dir(SpeichernDialog.DirPfad & "exactXML.xsl") = "exactXML.xsl" Then Kill SpeichernDialog.DirPfad & "exactXML.xsl"
    Open SpeichernDialog.DirPfad & "exactXML.xsl" For Binary As #1
        Put #1, , DataArray
    Close #1
ElseIf SpeichernDialog.XSL = 2 Then 'XSL mit lokalen Daten hinzufgen
    DataArray = LoadResData(101, "XSLT")
    RemoveNullBytes DataArray
    If Dir(SpeichernDialog.DirPfad & "exactXML.xsl") = "exactXML.xsl" Then Kill SpeichernDialog.DirPfad & "exactXML.xsl"
    Open SpeichernDialog.DirPfad & "exactXML.xsl" For Binary As #1
        Put #1, , DataArray
    Close #1
    If Dir(SpeichernDialog.DirPfad & "exactXML_data\") = "" Then
        MkDir SpeichernDialog.DirPfad & "exactXML_data\"
    Else
        Kill SpeichernDialog.DirPfad & "exactXML_data\*.*"
    End If
    LoadDataResource 101, "00.gif"
    LoadDataResource 102, "010.gif"
    LoadDataResource 103, "011.gif"
    LoadDataResource 104, "012.gif"
    LoadDataResource 105, "013.gif"
    LoadDataResource 106, "020.gif"
    LoadDataResource 107, "021.gif"
    LoadDataResource 108, "030.gif"
    LoadDataResource 109, "031.gif"
    LoadDataResource 110, "040.gif"
    LoadDataResource 111, "041.gif"
    LoadDataResource 112, "050.gif"
    LoadDataResource 113, "050a.gif"
    LoadDataResource 114, "051.gif"
    LoadDataResource 115, "051a.gif"
    LoadDataResource 116, "060.gif"
    LoadDataResource 117, "061.gif"
    LoadDataResource 118, "070.gif"
    LoadDataResource 119, "071.gif"
    LoadDataResource 120, "080.gif"
    LoadDataResource 121, "081.gif"
    LoadDataResource 122, "090.gif"
    LoadDataResource 123, "091.gif"
    LoadDataResource 124, "100.gif"
    LoadDataResource 125, "101.gif"
    LoadDataResource 126, "110.gif"
    LoadDataResource 127, "111.gif"
    LoadDataResource 128, "120.gif"
    LoadDataResource 129, "121.gif"
    LoadDataResource 130, "130.gif"
    LoadDataResource 131, "131.gif"
    LoadDataResource 132, "132.gif"
    LoadDataResource 133, "133.gif"
    LoadDataResource 134, "140.gif"
    LoadDataResource 135, "141.gif"
    LoadDataResource 136, "142.gif"
    LoadDataResource 137, "143.gif"
    LoadDataResource 138, "150.gif"
    LoadDataResource 139, "160.gif"
    LoadDataResource 140, "161.gif"
    LoadDataResource 141, "170.gif"
    LoadDataResource 142, "171.gif"
    LoadDataResource 143, "180.gif"
    LoadDataResource 144, "181.gif"
    LoadDataResource 145, "190.gif"
    LoadDataResource 146, "190a.gif"
    LoadDataResource 147, "191.gif"
    LoadDataResource 148, "191a.gif"
    LoadDataResource 149, "192.gif"
    LoadDataResource 150, "192a.gif"
    LoadDataResource 151, "193.gif"
    LoadDataResource 152, "193a.gif"
    LoadDataResource 153, "200.gif"
    LoadDataResource 154, "211.gif"
    LoadDataResource 155, "222.gif"
    LoadDataResource 156, "232.gif"
    LoadDataResource 157, "242.gif"
    LoadDataResource 158, "252.gif"
    LoadDataResource 159, "262.gif"
    LoadDataResource 160, "272.gif"
    LoadDataResource 161, "282.gif"
    LoadDataResource 162, "292.gif"
    LoadDataResource 163, "302.gif"
    LoadDataResource 164, "exact.gif"
    LoadDataResource 165, "exactXML.js", 1
    LoadDataResource 166, "print-high.gif"
    LoadDataResource 167, "print-low.gif"
    LoadDataResource 168, "prop-high.gif"
    LoadDataResource 169, "prop-low.gif"
    LoadDataResource 170, "round-left.gif"
    LoadDataResource 171, "round-middle.gif"
    LoadDataResource 172, "round-right.gif"
End If
End Sub

Private Sub LoadDataResource(IndexNr As Integer, FileName As String, Optional RNB As Byte)
Dim DataArray() As Byte
DataArray = LoadResData(IndexNr, "XSLTDATA")
If RNB = 1 Then RemoveNullBytes DataArray
Open SpeichernDialog.DirPfad & "exactXML_data\" & FileName For Binary As #1
    Put #1, , DataArray
Close #1
End Sub

'Sub zum Entfernen von Null-Bytes am Ende einer Textdatei
'Notwendig, da die Ressource Implentierung von VB anscheinend Fehler enthlt
Private Sub RemoveNullBytes(DataArray() As Byte)
Do Until DataArray(UBound(DataArray)) > 0
    ReDim Preserve DataArray(0 To UBound(DataArray) - 1)
Loop
End Sub
